unit Unitcumos;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

(**********************************************************************)
(* Paul Koop M.A. Cumos Coordinated undefined moving others           *)
(* Die Simulation wurde ursprunglich entwickelt,                      *)
(* um die Verwendbarkeit von Zellularautomaten                        *)
(* fuer die Algorithmisch Rekursive Sequanzanalyse                    *)
(* zu ueberpruefen						      *)
(* Modellcharakter hat allein der Quelltext. Eine Compilierung        *)
(* dient nur als Falsifikationsversuch                                *)
(**********************************************************************)

(*------------------------------------ Datenstruktur -----------------*)
CONST

 einCumo     = 'o';
 keinCumo    = ' ';
 anzahlCumos = 80;


TYPE
 cumo = RECORD
           x,y,xpos,ypos:integer;
        END;
 cumos = array[1..anzahlCumos] of cumo;

VAR
 a,b:cumos;
 SpielfeldArray: array [0..79,0..23] of char;

PROCEDURE zufall(VAR von:cumos);
PROCEDURE spiel(VAR von,nach :cumos);


implementation

USES dos,crt;



(*---------------------------------------- Prozeduren ---------------*)




PROCEDURE zufall(VAR von:cumos);
 VAR i,z:integer;
 BEGIN
  randomize;gotoxy(1,1);
  FOR i := 1 TO anzahlCumos
   DO
   BEGIN
    von(.i.).x:=random(80);
    von(.i.).y:=random(24);
    von(.i.).xpos:=random(3)-1;
    von(.i.).ypos:=random(3)-1;
    SpielfeldArray[von(.i.).x,von(.i.).y]:=eincumo;
   END;
 END;

PROCEDURE spiel(VAR von,nach :cumos);
 var i,j,xposn,yposn,vonix,voniy:integer;
 BEGIN
  FOR i:=1 TO anzahlCumos
   DO
   BEGIN

    xposn:= von(.i.).xpos;
    yposn:= von(.i.).ypos;

    FOR j:= 1 TO anzahlCumos
     DO
      BEGIN
       IF i<>j THEN
       BEGIN
       IF
          (
           (ABS((von(.j.).x-von(.i.).x))<2)
           AND
           (ABS((von(.j.).y-von(.i.).y))<2)
          )
        THEN
        BEGIN
        xposn:= xposn+von(.j.).xpos;
        yposn:= yposn+von(.j.).ypos;
        END;
       END;

      END;

       IF xposn <0 THEN xposn:=-1;
       IF xposn >0 THEN xposn:= 1;
       IF yposn <0 THEN yposn:=-1;
       IF yposn >0 THEN yposn:= 1;


       nach(.i.).x:=von(.i.).x+xposn;

       IF nach(.i.).x<0 THEN nach(.i.).x:=79;
       IF nach(.i.).x>79 THEN nach(.i.).x:=0;

       nach(.i.).y:=von(.i.).y+yposn;

       IF nach(.i.).y<0 THEN nach(.i.).y:=23;
       IF nach(.i.).y>23 THEN nach(.i.).y:=0;

       nach(.i.).xpos:=xposn;
       nach(.i.).ypos:=yposn;
       SpielfeldArray[von(.i.).x,von(.i.).y]:=keincumo;
       SpielfeldArray[nach(.i.).x,nach(.i.).y]:=eincumo;
   END;
 END;




end.

